/*
	Tasker Initialization
	add any costum initial taskers here
*/
function tasker_startup(){
	tasker_initiate();
}
/*
	tasker functions
*/
function Tasks_initialize(){
	tasker_create_task('#SYSTEM TASKER','tasker_test_tasks()',null,100);
	tasker_create_task('#SYSTEM FPS COUNTER','tasker_fps_count()',null,1000);
	tasker_create_task('#SYSTEM FPS FRAME COUNTER','TASKER_FRAMES++',null,1);
	tasker_create_task('#SYSTEM TIME COUNTER','SYSTEM_TIME_OBJECT = new Date()',null,1000);
	tasker_create_task('#SYSTEM DESKTOP CLEANER','desktop_cleaner();',null,10000);
	system_alert('Tasks initializing complete');
}
function tasker_test_tasks(){
	if(TASKER_FPS<20){
		if(!SYSTEM_LOW_FPS){
			SYSTEM_LOW_FPS_PASSES++;
			if(!SYSTEM_LOW_FPS){
				event_notify('Low FPS Alert',"System FPS is low, increasing task intervals. FPS: "+Math.round(TASKER_FPS));
			}
			SYSTEM_LOW_FPS = true;
		}
		for(i=0;i<TASKER_TASK_LIST.priority.length;i++){
			if(TASKER_TASK_LIST.task_commands[i] && TASKER_TASK_LIST.name[i].substring(0,7)!="#SYSTEM"){
				clearTimeout(TASKER_TASK_LIST.task_pointer[i]);
				commands = TASKER_TASK_LIST.task_commands[i];
				priority = TASKER_TASK_LIST.priority[i]+SYSTEM_LOW_FPS_PASSES;
				TASKER_TASK_LIST.task_pointer[i] = setInterval(commands,priority);
			}
		}
	}else if(SYSTEM_LOW_FPS){
		event_notify('FPS Alert Over',"System FPS is level after "+SYSTEM_LOW_FPS_PASSES+" passes. Resetting task intervals.");
		SYSTEM_LOW_FPS_PASSES = 0;
		for(i=0;i<TASKER_TASK_LIST.priority.length;i++){
			if(TASKER_TASK_LIST.task_commands[i]){
				clearTimeout(TASKER_TASK_LIST.task_pointer[i]);
				commands = TASKER_TASK_LIST.task_commands[i];
				priority = TASKER_TASK_LIST.priority[i];
				TASKER_TASK_LIST.task_pointer[i] = setInterval(commands,priority);
			}
		}
		SYSTEM_LOW_FPS = false;
	}
}
function tasker_create_task(title,commands,object,priority){
	task_number = TASKER_TASK_LIST.priority.length;
	TASKER_TASK_LIST.name[task_number] = title;
	if (commands){
		TASKER_TASK_LIST.task_commands[task_number] = commands;
		TASKER_TASK_LIST.task_pointer[task_number] = setInterval(commands,priority);
	}else{
		TASKER_TASK_LIST.task_commands[task_number] = false;
	}
	TASKER_TASK_LIST.task_object[task_number] = object;
	TASKER_TASK_LIST.priority[task_number] = priority;
}
function tasker_fps_count(){
	d = SYSTEM_TIME_OBJECT.getTime();
	TASKER_FPS = TASKER_FRAMES/((d-TASKER_LAST_FRAME)/1000);
	TASKER_LAST_FRAME = d;
	TASKER_FRAMES = 0;
}
function tasker_end_task(task_number){
	TASKER_TASK_LIST.name.splice(task_number,1);
	TASKER_TASK_LIST.task_commands.splice(task_number,1);
	TASKER_TASK_LIST.task_object.splice(task_number,1);
	TASKER_TASK_LIST.priority.splice(task_number,1);
	clearTimeout(TASKER_TASK_LIST.task_pointer[task_number]);
	TASKER_TASK_LIST.task_pointer.splice(task_number,1);
}
